;
; slrom menu 128k/256k PRG + 128k CHR
;

.include "littlenemo-charmap.asm"; кодировка шрифта

ARROW_SIGN = '*' ; символ стрелки
NBANK_FONT = 16 ; номер 4к банка с шрифтом (один экран 16х16)
RESET_OLD = $f43f+22 ; старое значение вектора сброса $fffc-$fffd

OFFSET_PRESET = $1f44f-16 ; смещение на неиспользуемое пространство в последнем банке (для переключения)
OFFSET_MENU = $bb00-16 ; смещение на неиспользуемое место для кода меню
OFFSET_MENU2 = $bd00-16 ; смещение на второе неиспользуемое место для кода меню


.linecont on ; разрыв строки по \
.feature c_comments; разрешение /* комментарий */

.include "nesdefs.inc"

JOYPAD1 = $4016
MMC3_SELECT  = $8000 ; select bank
MMC3_DATA    = $8001 
MMC3_RAMPRT  = $a001 ; ram protect
MMC3_IRQ     = $e000 ; disable mmc3 irq

; заголовок
.segment "INESHDR"
    INES_MAPPER = 4 ; 0 = NROM, 2 = UNROM, 1 = MMC1(AX5904), 4 = MMC3(AX5202P)
    INES_MIRROR = 0 ; 0 = horizontal mirroring, 1 = vertical mirroring
    INES_SRAM   = 1 ; 1 = battery backed SRAM at $6000-7FFF
    .byt $4E, $45, $53, $1A ; NES ID
    .byt 2 ; 16k PRG bank count
    .byt 16 ; 8k CHR bank count
    .byt INES_MIRROR | (INES_SRAM << 1) | ((INES_MAPPER & $f) << 4)
    .byt (INES_MAPPER & %11110000)


.ifdef OFFSET_PRESET
    ORG_PRESET = $8000 + $2000 + $2000 + (OFFSET_PRESET) .mod $4000
    .assert ((OFFSET_PRESET / $4000 = 7) .OR \
        (OFFSET_PRESET / $4000 = 15)), error , "OFFSET_PRESET не в последнем банке"
    ORG_MENU = $8000 + OFFSET_MENU .mod $4000
    NBANK_PRG = OFFSET_MENU / $4000 * 2
    .out .sprintf ("Номер банка для кода = %d", NBANK_PRG)
    .out .sprintf ("Номер последнего банка = %d", OFFSET_PRESET / $4000 )
    .out .sprintf ("Новый вектор сброса = $%X (%02X %02X)", ORG_PRESET, ORG_PRESET .mod $100, ORG_PRESET / $100)

.elseif .defined(OFFSET_MENU)
    ORG_MENU = $8000 + $2000 + $2000 + (OFFSET_MENU) .mod $4000
    .assert ((OFFSET_MENU / $4000 = 7) .OR \
        (OFFSET_MENU / $4000 = 15)), error , "OFFSET_MENU не в последнем банке"
    .out .sprintf ("Номер последнего банка = %d", OFFSET_MENU / $4000 )
    .out .sprintf ("Новый вектор сброса = $%X (%02X %02X)", ORG_MENU, ORG_MENU .mod $100, ORG_MENU / $100)
.endif


.ifdef OFFSET_MENU2
    .ifndef OFFSET_PRESET
        OFFSET_PRESET = -1 ; (.defined() .AND ...) не работает как ожидается
    .endif
    .if (OFFSET_PRESET / $4000 = OFFSET_MENU2 / $4000 ) ; OFFSET_MENU2 вместе с OFFSET_PRESET
        ORG_MENU2 = $8000 + $2000 + $2000 + OFFSET_MENU2 .mod $4000
    .elseif (OFFSET_MENU / $4000 = OFFSET_MENU2 / $4000 ) ; OFFSET_MENU2 вместе с OFFSET_MENU
        ORG_MENU2 = (ORG_MENU / $4000) * $4000 + OFFSET_MENU2 .mod $4000
    .else
        .error "OFFSET_MENU2 в неправильном банке"
    .endif
.endif


; векторы прерываний
.segment "VECTORS"
    .addr nmi_isr, reset, irq_isr

; переменные
.segment "ZEROPAGE"
joy1:           .res 1 ; состояние джойстика
joy1prv:        .res 1 ; предыдущее состояние
codehere:       .res 1 ; начало кода лаунчера


; код
.segment "CODE"

nmi_isr:; прерывание nmi
irq_isr:; прерывание irq
	rti

.ifdef ORG_PRESET
    .byt $50, $52, $45, $53, $45, $54 ; "PRESET"
    .org ORG_PRESET ; код переключения
    sei
    ;     CPMxxRRR
    ldx #%00000110 ; банк 8k PRG $8000-$9FFF
    stx MMC3_SELECT
    ldy #NBANK_PRG
    sty MMC3_DATA
    inx
    stx MMC3_SELECT
    iny
    sty MMC3_DATA
    jmp ORG_MENU
.endif


.ifdef ORG_MENU
    .byt $4d, $45, $4e, $55; "MENU"
    .org ORG_MENU
.endif
reset:

.ifndef ORG_PRESET
    sei
.endif
    cld
    ldx #$40
    stx APU_FRAME
    ldx #$ff
    txs ; указатель стека

    inx ; ldx #0
	stx PPU_CTRL		; запрет NMI
	stx PPU_MASK		; отключение спрайтов и фона
    stx APU_DMC_CTRL    ; отключение DMC IRQ
    stx MMC3_IRQ

    ; ждем 2 vblank
    bit PPU_STATUS
:   bit PPU_STATUS
    bpl :-
:   bit PPU_STATUS
    bpl :-

    ; переключаем банк chr 
    lda #NBANK_FONT ; номер 4к банка (один экран 16х16)
    asl a
    asl a
    ;     CPMxxRRR
    ldx #%00000000 ; R0=0
    stx MMC3_SELECT
    sta MMC3_DATA
    inx ; R1=1
    adc #%00000010 ; A=A+2; следующий 2k банк
    stx MMC3_SELECT
    sta MMC3_DATA

    ; перемещаем все спрайты x=255,y=255
    ldx #0
	lda #$ff
:	sta OAM_RAM, x
	inx
	bne :-

    ; настраиваем спрайт курсора
    sta OAM_RAM+0 ; у
    lda #ARROW_SIGN ; символ курсора
    sta OAM_RAM+1 ; номер спрайта
    lda #%00010000 | 2 ; номер палитры 0-3
    sta OAM_RAM+2 ; атрибут
    lda #(8*2+4)
    sta OAM_RAM+3 ; x

    ; загрузка палитры
    ldx #>$3F00
    stx PPU_ADDR
    ldx #<$3F00
    stx PPU_ADDR

    ;фона
	ldx #0
:	lda palette,x
	sta PPU_DATA
	inx
	cpx #16
	bcc :-

    ; спрайтов, та же самая палитра
    ldx #0
:	lda palette,x
	sta PPU_DATA
	inx
	cpx #16
	bcc :-
    

    ; очистка первой экранной страницы
    ldx #>$2000
    stx PPU_ADDR
    ldx #<$2000
    stx PPU_ADDR
	lda #' ' ; пустой тайл
	ldx #32*30/4	; 32*30/4=960/4=240
:	sta PPU_DATA
	sta PPU_DATA
	sta PPU_DATA
	sta PPU_DATA
	dex
	bne :-

    ; палитра для первой строки, PPU_ADDR уже установлен
	ldx #8
	lda #%00000000	; палитра 0
:	sta PPU_DATA
	dex
	bne :-

    ; палитра для второй строки, PPU_ADDR установлен
	ldx #8
	lda #%10100101	; палитра 1
:	sta PPU_DATA
	dex
	bne :-

    ; палитра для все остальных строк, PPU_ADDR установлен
	ldx #(64-8-8)
	lda #%10101010
:	sta PPU_DATA
	dex
	bne :-

    ; загружаем текст меню в 1 страницу
    ldx #>$2000
    stx PPU_ADDR
    ldx #<$2000
    stx PPU_ADDR

    ; печатаем текст
    ;ldx #0 ; #<$2000 == #0

    ldy text_menu, x ; количество пробелов
@print_line:
    lda #' '
:   sta PPU_DATA
    dey
    bne :-

    inx
    ldy text_menu, x ; количество символов
:   inx
    lda text_menu, x ; символ
    sta PPU_DATA
    dey
    bne :-

    inx
    ldy text_menu, x ; количество пробелов
    bne @print_line ; пробелов 0 - конец


    ; настройка PPU
	lda #BG_0|SPR_0|NT_0|VRAM_RIGHT
	sta PPU_CTRL

	; включение спрайтов и бекграунда
	lda #BG_ON|SPR_ON|HIDE_BG_LHS|HIDE_SPR_LHS
	sta PPU_MASK

    ldy #0 ; выбранный пункт
mainloop:
    
    ; чтение джойстика
    lda #$01
    sta JOYPAD1
    sta joy1
    lsr a        ; A=0
    sta JOYPAD1
:   lda JOYPAD1
    lsr a	    ; bit0 -> Carry
    bcs :+ ; чтение 3 джойстика
    lsr a
:   rol joy1  ; Carry -> bit0; bit 7 -> Carry
    bcc :--

    ; фильтруем только нажатия
    lda joy1
    tax
    eor joy1prv
    and joy1
    stx joy1prv

    ; двигаем курсор
    ;bit:   	 7     6     5     4     3     2     1     0
    ;button:	 A     B  Select Start  Up   Down  Left  Right
    ror a ; 0bit Right
    ror a ; 1bit Left
    ror a ; 2bit Down
    bcc :+
    iny
:   ror a ; 3bit Up
    bcc :+
    dey
:   ror a ; 4bit Start
    bcs launch ; запускаем игру

    tya
    and #%11 ; ограничиваем пунткы 0-3 (1-4)
    tay

    clc
    adc #$03 ; начинается с 7 строки экрана
    asl a ; a = a*16
    asl a
    asl a
    asl a
    ;clc
    adc #$05 ; курсор по центру строки

:   bit PPU_STATUS
    bpl :-

    sta OAM_RAM+0 ; позиция курсора по у
	lda #>OAM_RAM ; вызов DMA
	sta OAM_DMA

    jmp mainloop


launch:; переключаем игру, в Y индекс банка из banktable

    ;     RWxxxxxx
    lda #%10000000
    sta MMC3_RAMPRT

	; тушим экран, выключение спрайтов и бекграунда
	lda #BG_OFF|SPR_OFF|HIDE_BG_LHS|HIDE_SPR_LHS
	sta PPU_MASK

    ; копируем лаунчер в озу
    ldx #(launcher_end - launcher); количество байт в лаунчере
:   dex
    lda launcher, x
    sta codehere, x
    txa
    bne :-
    
    ldx banktable, y
    jmp codehere


.ifdef ORG_MENU2; деление кода на две части, если не влезает
    .byt $4d, $45, $4e, $55, $32; "MENU"
    .org ORG_MENU2
.endif
    
launcher:
    lda $6000, x
    ;sta $6000, x
    txa
    and #%011 ; проверка на нулевую игру
    bne :+
    jmp RESET_OLD
:
    jmp ($fffc)
launcher_end:


banktable:
    ; A2 - A13 WRAM
    ; A1 - A18 PRG+CHR (256k), A14 WRAM
    ; A0 - A17 WRAMCHR (128k)
    ;    A210    (3) A17 REG  раъединен     (3) A17 REG соединен
    ;.byt %000 ; 128k bank0 + WRAM bank0 | 256k bank0 + WRAM bank0
    ;.byt %100 ; 128k bank0 + WRAM bank1 | 256k bank0 + WRAM bank1
    .byt %001 ; 128k bank1 + WRAM bank0 | 256k bank0 + WRAM bank0
    ;.byt %101 ; 128k bank1 + WRAM bank1 | 256k bank0 + WRAM bank1
    .byt %010 ; 128k bank2 + WRAM bank2 | 256k bank1 + WRAM bank2
    ;.byt %110 ; 128k bank2 + WRAM bank3 | 256k bank1 + WRAM bank3
    .byt %011 ; 128k bank3 + WRAM bank2 | 256k bank1 + WRAM bank2
    ;.byt %111 ; 128k bank3 + WRAM bank3 | 256k bank1 + WRAM bank3

    .byt %000 ; 128k bank0 + WRAM bank0 | 256k bank0 + WRAM bank0


    

palette:
    ; палитра
	.byt $0f, $29, $19, $39; зеленый
	.byt $0f, $28, $18, $38; оранжевый
	.byt $0f, $21, $11, $31; синий
	.byt $0f, $25, $15, $35; розовый


text_menu:
    ; количество пробелов, длинна строки, строка
    .include "menu-text.asm"

.segment "CHR"
	.incbin "Little Nemo - The Dream Master (E) [!].nes.chr"

; vim:ft=a65:
